<template>
  <b-container>
    <div class="background_bloc" />
    <h1 class="title">
      Mes produits
    </h1>
  </b-container>

  <b-container>
    <b-tabs content-class="mt-3">
      <b-tab
        title="MODIFIER"
        active
      >
        <b-row v-if="!produits.length">
          Vous n'avez pas publié de produit pour le moment, n'attendez plus pour en ajouter en cliquant sur l'onglet "ajouter" juste au dessus!
        </b-row>
        <b-row v-else>
          <b-col 
            v-for="(produit, index) in produits"
            :key="produit"
            sm="12"
            md="4"
          >
            <CardProduit
              :id="produit.id"
              :id-vendeur="produit.vendeur.id"
              :titre="produit.titre"
              :prix="produit.prix"
              :image="images[index]"
              :editable="1"
            />
          </b-col>
        </b-row>
      </b-tab>
      <b-tab title="AJOUTER">
        <b-form>
          <b-form-group>
            <label>Catégorie :</label>
            <select
              v-model="selectedCategories"
              class="form-select"
            >
              <option
                v-for="cat in categories"
                :key="cat"
                :value="cat.id"
              >
                {{ cat.nom }}
              </option>       
            </select>
          </b-form-group>
          <b-form-group>
            <label>Titre :</label>
            <b-form-input
              v-model="titre"
              type="text"
              required
            />
          </b-form-group>
          <b-form-group>
            <label>Description :</label>
            <b-form-input
              v-model="description"
              type="text"
              required
            />
          </b-form-group>
          <div class="d-flex">
            <b-form-group class="w-100">
              <label for="feedback-pseudo">Prix :</label>
              <b-form-input
                v-model="prix"
                type="number"
                required
              />
            </b-form-group>
            <b-form-group class="w-100">
              <label>Quantité :</label>  
              <b-form-input
                v-model="quantite"
                type="number"
                required
              />
            </b-form-group>
          </div>
          <b-form-group>
            <label for="avatar">Image 1 :</label>
            <input
              id="avatar"
              type="file"
              name="avatar"
              accept="image/png, image/jpeg"
              @change="onFileUpload($event)"
            >
            <label for="avatar">Image 2 :</label>
            <input
              id="avatar"
              type="file"
              name="avatar"
              accept="image/png, image/jpeg"
              @change="onFileUpload($event)"
            >
            <label for="avatar">Image 3 :</label>
            <input
              id="avatar"
              type="file"
              name="avatar"
              accept="image/png, image/jpeg"
              @change="onFileUpload($event)"
            >
          </b-form-group>
          <div class="button d-flex justify-content-end">
            <button
              class="submit btn-cta"
              type="submit"
              @click.prevent="addProduct($event)"
            >
              Enregistrer
            </button>
          </div>
        </b-form>
      </b-tab>
    </b-tabs>
  </b-container>

  <Modal
    ref="modalMsg"
    :message="message"
    :choix="false"
  />
</template>

<script>
import Modal from '@/components/Modal.vue';
import { useStore } from '@/store/store'
import axios from 'axios';
import CardProduit from '@/components/CardProduit.vue'


 export default {
    components: {
      Modal,
      CardProduit,
    },

    data() {
        const store = useStore();

        return {
            token: store.token,
            store,
            produits: [],
            titre: '',
            description: '',
            prix: 0,
            quantite: 0,
            arrFile: [],
            message: '',
            url: process.env.VUE_APP_URL,
            categories: [],
            selectedCategories: '',
            images: []
            
        }
    },

    mounted() {
        // on récupère les catégories de produit
        axios.get(this.url + "/api/categories")          
                    .then(response => {
                        if(response.data['hydra:member'].length > 0){
                            response.data['hydra:member'].forEach(cat => {
                                this.categories.push(cat);
                                })
                        }
                    })
                    .catch(err => console.log(err))

        // on récupère les produits déjà postés
        if(this.store.isConnected){
        this.store.fetchSeller(this.store.user.id).then( res => {
            if(this.store.seller.produits.length > 0){
              this.store.seller.produits.forEach(produit => {
                axios.get(this.url + "/api/produits/" + produit.id)
                .then(res => {
                if(res.data.mediaObjects[0] == undefined){
                    this.images.push('noimg');
                } else {
                    this.images.push(res.data.mediaObjects[0].contentUrl);
                }
                  this.produits.push(res.data);
                })
                .catch(err => {
                    console.log(err)
                })
              });
            }
        })
      }
    },
    

    methods: {

        onFileUpload(event) {
            this.arrFile.push(event.target.files[0]);
        },

        addImages(produit_id) {

            if(this.arrFile.length > 0){
                this.arrFile.forEach(file => {
                    console.log(file);
                    axios.post(this.url + "/api/media_objects", {
                        "produit_id": produit_id,
                        "file": file,
                    },
                    {
                        headers: {
                                "Content-Type": "multipart/form-data"
                        }
                    })          
                   .then(response => {
                    console.log(response.data)
                   })
                   .catch(err => console.log(err))
                });
            }

        },

        addProduct() {

            const store = useStore();
            axios.get(this.url + "/api/info_vendeurs/getbyid/" + store.user.id)
            .then(res => {
                if(res.data['hydra:member'].length > 0){
                    axios.post(this.url + "/api/produits", {
                        "categorie": "api/categories/" + this.selectedCategories,
                        "vendeur": "api/info_vendeurs/" + res.data['hydra:member'][0].id,
                        "titre": this.titre,
                        "description": this.description,
                        "prix": parseInt(this.prix),
                        "afficher": true,
                        "quantite": parseInt(this.quantite),
                        "publication": new Date()
                    })          
                    .then(response => {
                            this.addImages(response.data.id);
                            this.message = 'Votre produit a bien été ajouté.';
                            this.$refs.modalMsg.show = true
                    })
                    .catch(err => console.log(err))
                    }
                })
            .catch(err => {
                console.log(err)
            })

        }
     }
 }
</script>

           


        

